/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1beta1 "github.com/linkerd/linkerd2/controller/gen/apis/externalworkload/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeExternalWorkloads implements ExternalWorkloadInterface
type FakeExternalWorkloads struct {
	Fake *FakeExternalworkloadV1beta1
	ns   string
}

var externalworkloadsResource = v1beta1.SchemeGroupVersion.WithResource("externalworkloads")

var externalworkloadsKind = v1beta1.SchemeGroupVersion.WithKind("ExternalWorkload")

// Get takes name of the externalWorkload, and returns the corresponding externalWorkload object, and an error if there is any.
func (c *FakeExternalWorkloads) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.ExternalWorkload, err error) {
	emptyResult := &v1beta1.ExternalWorkload{}
	obj, err := c.Fake.
		Invokes(testing.NewGetActionWithOptions(externalworkloadsResource, c.ns, name, options), emptyResult)

	if obj == nil {
		return emptyResult, err
	}
	return obj.(*v1beta1.ExternalWorkload), err
}

// List takes label and field selectors, and returns the list of ExternalWorkloads that match those selectors.
func (c *FakeExternalWorkloads) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.ExternalWorkloadList, err error) {
	emptyResult := &v1beta1.ExternalWorkloadList{}
	obj, err := c.Fake.
		Invokes(testing.NewListActionWithOptions(externalworkloadsResource, externalworkloadsKind, c.ns, opts), emptyResult)

	if obj == nil {
		return emptyResult, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.ExternalWorkloadList{ListMeta: obj.(*v1beta1.ExternalWorkloadList).ListMeta}
	for _, item := range obj.(*v1beta1.ExternalWorkloadList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested externalWorkloads.
func (c *FakeExternalWorkloads) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchActionWithOptions(externalworkloadsResource, c.ns, opts))

}

// Create takes the representation of a externalWorkload and creates it.  Returns the server's representation of the externalWorkload, and an error, if there is any.
func (c *FakeExternalWorkloads) Create(ctx context.Context, externalWorkload *v1beta1.ExternalWorkload, opts v1.CreateOptions) (result *v1beta1.ExternalWorkload, err error) {
	emptyResult := &v1beta1.ExternalWorkload{}
	obj, err := c.Fake.
		Invokes(testing.NewCreateActionWithOptions(externalworkloadsResource, c.ns, externalWorkload, opts), emptyResult)

	if obj == nil {
		return emptyResult, err
	}
	return obj.(*v1beta1.ExternalWorkload), err
}

// Update takes the representation of a externalWorkload and updates it. Returns the server's representation of the externalWorkload, and an error, if there is any.
func (c *FakeExternalWorkloads) Update(ctx context.Context, externalWorkload *v1beta1.ExternalWorkload, opts v1.UpdateOptions) (result *v1beta1.ExternalWorkload, err error) {
	emptyResult := &v1beta1.ExternalWorkload{}
	obj, err := c.Fake.
		Invokes(testing.NewUpdateActionWithOptions(externalworkloadsResource, c.ns, externalWorkload, opts), emptyResult)

	if obj == nil {
		return emptyResult, err
	}
	return obj.(*v1beta1.ExternalWorkload), err
}

// Delete takes name of the externalWorkload and deletes it. Returns an error if one occurs.
func (c *FakeExternalWorkloads) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(externalworkloadsResource, c.ns, name, opts), &v1beta1.ExternalWorkload{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeExternalWorkloads) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionActionWithOptions(externalworkloadsResource, c.ns, opts, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta1.ExternalWorkloadList{})
	return err
}

// Patch applies the patch and returns the patched externalWorkload.
func (c *FakeExternalWorkloads) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.ExternalWorkload, err error) {
	emptyResult := &v1beta1.ExternalWorkload{}
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceActionWithOptions(externalworkloadsResource, c.ns, name, pt, data, opts, subresources...), emptyResult)

	if obj == nil {
		return emptyResult, err
	}
	return obj.(*v1beta1.ExternalWorkload), err
}
