/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1alpha2

import (
	"context"

	v1alpha2 "github.com/linkerd/linkerd2/controller/gen/apis/link/v1alpha2"
	scheme "github.com/linkerd/linkerd2/controller/gen/client/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	gentype "k8s.io/client-go/gentype"
)

// LinksGetter has a method to return a LinkInterface.
// A group's client should implement this interface.
type LinksGetter interface {
	Links(namespace string) LinkInterface
}

// LinkInterface has methods to work with Link resources.
type LinkInterface interface {
	Create(ctx context.Context, link *v1alpha2.Link, opts v1.CreateOptions) (*v1alpha2.Link, error)
	Update(ctx context.Context, link *v1alpha2.Link, opts v1.UpdateOptions) (*v1alpha2.Link, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha2.Link, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha2.LinkList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha2.Link, err error)
	LinkExpansion
}

// links implements LinkInterface
type links struct {
	*gentype.ClientWithList[*v1alpha2.Link, *v1alpha2.LinkList]
}

// newLinks returns a Links
func newLinks(c *LinkV1alpha2Client, namespace string) *links {
	return &links{
		gentype.NewClientWithList[*v1alpha2.Link, *v1alpha2.LinkList](
			"links",
			c.RESTClient(),
			scheme.ParameterCodec,
			namespace,
			func() *v1alpha2.Link { return &v1alpha2.Link{} },
			func() *v1alpha2.LinkList { return &v1alpha2.LinkList{} }),
	}
}
