/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"

	v1alpha1 "github.com/linkerd/linkerd2/controller/gen/apis/policy/v1alpha1"
	scheme "github.com/linkerd/linkerd2/controller/gen/client/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	gentype "k8s.io/client-go/gentype"
)

// MeshTLSAuthenticationsGetter has a method to return a MeshTLSAuthenticationInterface.
// A group's client should implement this interface.
type MeshTLSAuthenticationsGetter interface {
	MeshTLSAuthentications(namespace string) MeshTLSAuthenticationInterface
}

// MeshTLSAuthenticationInterface has methods to work with MeshTLSAuthentication resources.
type MeshTLSAuthenticationInterface interface {
	Create(ctx context.Context, meshTLSAuthentication *v1alpha1.MeshTLSAuthentication, opts v1.CreateOptions) (*v1alpha1.MeshTLSAuthentication, error)
	Update(ctx context.Context, meshTLSAuthentication *v1alpha1.MeshTLSAuthentication, opts v1.UpdateOptions) (*v1alpha1.MeshTLSAuthentication, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.MeshTLSAuthentication, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.MeshTLSAuthenticationList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.MeshTLSAuthentication, err error)
	MeshTLSAuthenticationExpansion
}

// meshTLSAuthentications implements MeshTLSAuthenticationInterface
type meshTLSAuthentications struct {
	*gentype.ClientWithList[*v1alpha1.MeshTLSAuthentication, *v1alpha1.MeshTLSAuthenticationList]
}

// newMeshTLSAuthentications returns a MeshTLSAuthentications
func newMeshTLSAuthentications(c *PolicyV1alpha1Client, namespace string) *meshTLSAuthentications {
	return &meshTLSAuthentications{
		gentype.NewClientWithList[*v1alpha1.MeshTLSAuthentication, *v1alpha1.MeshTLSAuthenticationList](
			"meshtlsauthentications",
			c.RESTClient(),
			scheme.ParameterCodec,
			namespace,
			func() *v1alpha1.MeshTLSAuthentication { return &v1alpha1.MeshTLSAuthentication{} },
			func() *v1alpha1.MeshTLSAuthenticationList { return &v1alpha1.MeshTLSAuthenticationList{} }),
	}
}
