/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"

	v1alpha1 "github.com/linkerd/linkerd2/controller/gen/apis/policy/v1alpha1"
	scheme "github.com/linkerd/linkerd2/controller/gen/client/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	gentype "k8s.io/client-go/gentype"
)

// NetworkAuthenticationsGetter has a method to return a NetworkAuthenticationInterface.
// A group's client should implement this interface.
type NetworkAuthenticationsGetter interface {
	NetworkAuthentications(namespace string) NetworkAuthenticationInterface
}

// NetworkAuthenticationInterface has methods to work with NetworkAuthentication resources.
type NetworkAuthenticationInterface interface {
	Create(ctx context.Context, networkAuthentication *v1alpha1.NetworkAuthentication, opts v1.CreateOptions) (*v1alpha1.NetworkAuthentication, error)
	Update(ctx context.Context, networkAuthentication *v1alpha1.NetworkAuthentication, opts v1.UpdateOptions) (*v1alpha1.NetworkAuthentication, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.NetworkAuthentication, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.NetworkAuthenticationList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.NetworkAuthentication, err error)
	NetworkAuthenticationExpansion
}

// networkAuthentications implements NetworkAuthenticationInterface
type networkAuthentications struct {
	*gentype.ClientWithList[*v1alpha1.NetworkAuthentication, *v1alpha1.NetworkAuthenticationList]
}

// newNetworkAuthentications returns a NetworkAuthentications
func newNetworkAuthentications(c *PolicyV1alpha1Client, namespace string) *networkAuthentications {
	return &networkAuthentications{
		gentype.NewClientWithList[*v1alpha1.NetworkAuthentication, *v1alpha1.NetworkAuthenticationList](
			"networkauthentications",
			c.RESTClient(),
			scheme.ParameterCodec,
			namespace,
			func() *v1alpha1.NetworkAuthentication { return &v1alpha1.NetworkAuthentication{} },
			func() *v1alpha1.NetworkAuthenticationList { return &v1alpha1.NetworkAuthenticationList{} }),
	}
}
