/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1beta1

import (
	"context"

	v1beta1 "github.com/linkerd/linkerd2/controller/gen/apis/serverauthorization/v1beta1"
	scheme "github.com/linkerd/linkerd2/controller/gen/client/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	gentype "k8s.io/client-go/gentype"
)

// ServerAuthorizationsGetter has a method to return a ServerAuthorizationInterface.
// A group's client should implement this interface.
type ServerAuthorizationsGetter interface {
	ServerAuthorizations(namespace string) ServerAuthorizationInterface
}

// ServerAuthorizationInterface has methods to work with ServerAuthorization resources.
type ServerAuthorizationInterface interface {
	Create(ctx context.Context, serverAuthorization *v1beta1.ServerAuthorization, opts v1.CreateOptions) (*v1beta1.ServerAuthorization, error)
	Update(ctx context.Context, serverAuthorization *v1beta1.ServerAuthorization, opts v1.UpdateOptions) (*v1beta1.ServerAuthorization, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1beta1.ServerAuthorization, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1beta1.ServerAuthorizationList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.ServerAuthorization, err error)
	ServerAuthorizationExpansion
}

// serverAuthorizations implements ServerAuthorizationInterface
type serverAuthorizations struct {
	*gentype.ClientWithList[*v1beta1.ServerAuthorization, *v1beta1.ServerAuthorizationList]
}

// newServerAuthorizations returns a ServerAuthorizations
func newServerAuthorizations(c *ServerauthorizationV1beta1Client, namespace string) *serverAuthorizations {
	return &serverAuthorizations{
		gentype.NewClientWithList[*v1beta1.ServerAuthorization, *v1beta1.ServerAuthorizationList](
			"serverauthorizations",
			c.RESTClient(),
			scheme.ParameterCodec,
			namespace,
			func() *v1beta1.ServerAuthorization { return &v1beta1.ServerAuthorization{} },
			func() *v1beta1.ServerAuthorizationList { return &v1beta1.ServerAuthorizationList{} }),
	}
}
