/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1alpha2

import (
	"context"

	v1alpha2 "github.com/linkerd/linkerd2/controller/gen/apis/serviceprofile/v1alpha2"
	scheme "github.com/linkerd/linkerd2/controller/gen/client/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	gentype "k8s.io/client-go/gentype"
)

// ServiceProfilesGetter has a method to return a ServiceProfileInterface.
// A group's client should implement this interface.
type ServiceProfilesGetter interface {
	ServiceProfiles(namespace string) ServiceProfileInterface
}

// ServiceProfileInterface has methods to work with ServiceProfile resources.
type ServiceProfileInterface interface {
	Create(ctx context.Context, serviceProfile *v1alpha2.ServiceProfile, opts v1.CreateOptions) (*v1alpha2.ServiceProfile, error)
	Update(ctx context.Context, serviceProfile *v1alpha2.ServiceProfile, opts v1.UpdateOptions) (*v1alpha2.ServiceProfile, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha2.ServiceProfile, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha2.ServiceProfileList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha2.ServiceProfile, err error)
	ServiceProfileExpansion
}

// serviceProfiles implements ServiceProfileInterface
type serviceProfiles struct {
	*gentype.ClientWithList[*v1alpha2.ServiceProfile, *v1alpha2.ServiceProfileList]
}

// newServiceProfiles returns a ServiceProfiles
func newServiceProfiles(c *LinkerdV1alpha2Client, namespace string) *serviceProfiles {
	return &serviceProfiles{
		gentype.NewClientWithList[*v1alpha2.ServiceProfile, *v1alpha2.ServiceProfileList](
			"serviceprofiles",
			c.RESTClient(),
			scheme.ParameterCodec,
			namespace,
			func() *v1alpha2.ServiceProfile { return &v1alpha2.ServiceProfile{} },
			func() *v1alpha2.ServiceProfileList { return &v1alpha2.ServiceProfileList{} }),
	}
}
