/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1beta2

import (
	v1beta2 "github.com/linkerd/linkerd2/controller/gen/apis/server/v1beta2"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/listers"
	"k8s.io/client-go/tools/cache"
)

// ServerLister helps list Servers.
// All objects returned here must be treated as read-only.
type ServerLister interface {
	// List lists all Servers in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta2.Server, err error)
	// Servers returns an object that can list and get Servers.
	Servers(namespace string) ServerNamespaceLister
	ServerListerExpansion
}

// serverLister implements the ServerLister interface.
type serverLister struct {
	listers.ResourceIndexer[*v1beta2.Server]
}

// NewServerLister returns a new ServerLister.
func NewServerLister(indexer cache.Indexer) ServerLister {
	return &serverLister{listers.New[*v1beta2.Server](indexer, v1beta2.Resource("server"))}
}

// Servers returns an object that can list and get Servers.
func (s *serverLister) Servers(namespace string) ServerNamespaceLister {
	return serverNamespaceLister{listers.NewNamespaced[*v1beta2.Server](s.ResourceIndexer, namespace)}
}

// ServerNamespaceLister helps list and get Servers.
// All objects returned here must be treated as read-only.
type ServerNamespaceLister interface {
	// List lists all Servers in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta2.Server, err error)
	// Get retrieves the Server from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1beta2.Server, error)
	ServerNamespaceListerExpansion
}

// serverNamespaceLister implements the ServerNamespaceLister
// interface.
type serverNamespaceLister struct {
	listers.ResourceIndexer[*v1beta2.Server]
}
